/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "tile.h"

tilemap_t * tileMapCreate(tileset_t *tileset) {
  tilemap_t *tilemap = malloc(sizeof(tilemap_t));
  if(tilemap == NULL) return NULL;

  tilemap->tileset = tileset;
  tilemap->tileDefinitions = calloc(tileset->columns * tileset->rows,
    sizeof(tiledef_t)
  );
  if(!tilemap->tileDefinitions) {
    free(tilemap);
    return NULL;
  }

  

  // tilemap->tileDefinitions->indiceCount = 6;
  // tilemap->tileDefinitions->verticeCount = 4;

  // (tilemap->tileDefinitions + 1)->indiceCount = 6;
  // (tilemap->tileDefinitions + 1)->verticeCount = 4;

  (tilemap->tileDefinitions + 2)->indiceCount = 6;
  (tilemap->tileDefinitions + 2)->verticeCount = 4;

  return tilemap;
}

void tileMapDispose(tilemap_t *tilemap) {
  free(tilemap->tileDefinitions);
  free(tilemap);
}