// Copyright (c) 2021 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "chunklist.h"
#include "tile.h"
#include "../display/shader.h"
#include "../display/tileset.h"
#include "../display/texture.h"
#include "../file/asset.h"

typedef struct {
  chunklist_t *chunkList;
  texture_t *texture;
  tileset_t *tileset;
  tilemap_t *tilemap;
} world_t;

world_t * worldCreate();

void worldRender(world_t *world, shader_t *shader);

void worldDispose(world_t *world);